// -*- Mode:C++ -*-
//Header:
//File: pipedclient.cc
//Author: NDOA, Itsuki
//Date: 1999/04/17
//

//ModifyHistory:
// 1999/04/17: Create this file
//EndModifyHistory:

#include "libsclient.h"

ScBool receiveLoop(ScSocket& sock, ostream& ostr) {
   ScString buf(SC_BUFSIZE) ;
   while(ScTrue) {
      sock.recv(buf) ;
      ostr << buf << flush ;
   }
   return ScTrue ;
}

ScSocket* Sock ;
ostream * OStr ;

void* receiveLoopEntry(void* ignore) {  receiveLoop(*Sock, *OStr) ; } 

ScBool sendLoop(ScSocket& sock, istream& istr) {
   ScString buf(SC_BUFSIZE) ;
   while(ScTrue) {
      istr.getline((char*)buf,buf.length()) ;
      if(!sock.send(buf)) {
	 cerr << "Error: fail to send." << endl ;
	 return ScFalse ;
      }
   }
   return ScTrue ;
}
   
mainloop(ScSocket& sock, istream& istr, ostream& ostr) {
   if (0) {
      ScString buf(SC_BUFSIZE) ;
      istr.getline((char*)buf,buf.length()) ;
      sock.send(buf) ;
      sock.recv(buf) ;
      ostr << buf << flush ;
   }

   Sock = &sock ;
   OStr = &ostr ;
   pthread_t pid ;
   pthread_create(&pid, SC_NULLPTR, receiveLoopEntry, SC_NULLPTR) ;
   
   sendLoop(sock,istr) ;
}

main(int argc, char** argv) {

   char* host ;   host = "localhost" ;
   ScInt port = 6000 ;

   if(argc >= 2) host = argv[1] ;
   if(argc >= 3) port = atol(argv[2]) ;

   cout << "Try to open socket to host:port=" 
	<< host << ":" << port << endl ;
   
   ScSocket sock(host,port,ScFalse) ;

   cout << "Succeed to open socket." << endl ;

   cout << "Enter pipe loop." << endl ;
   mainloop(sock,cin,cout) ;

}


