// -*- Mode:C++ -*-
//Header:
//File: bipred.h
//Title: built-in predicate 
//Author: NODA Itsuki
//Date: 1998/6/19
//EndHeader:

//ModifyHistory:
// 1998/6/19: Create this file
//EndModifyHistory:

//Memo:
//EndMemo:

#ifndef _BIPRED_H_
#define _BIPRED_H_
////////////////////////////////////////////////////////////////////////

#include "bip_util.h"

extern "C" {
   extern Bool bipredInit_ctl() ;
   extern Bool bipredInit_misc() ;
   extern Bool bipredInit_data() ;
   extern Bool bipredInit_io() ;
   extern Bool bipredInit_env() ;
   extern Bool bipredInit_proc() ;
   extern Bool bipredInit_arith() ;
}

inline Bool bipredInit() {
   return bipredInit_ctl() 
      &&  bipredInit_misc() 
      &&  bipredInit_data() 
      &&  bipredInit_io() 
      &&  bipredInit_env() 
      &&  bipredInit_proc() 
      &&  bipredInit_arith() 
      ;
} ;

////////////////////////////////////////////////////////////////////////
#endif

