#ifndef _gglobal_h_
#define _gglobal_h_
////////////////////////////////////////////////////////////////////////

#include "gdata.h"


extern GaeaData NullSymbol ;
#define _NullSymbol _SymVal(NullSymbol)

extern GaeaData AnonymousVar ;

extern GaeaData ErrorSymbol ;

extern GaeaData EOFSymbol ;

extern GaeaData YesSymbol ;
extern GaeaData NoSymbol ;
extern GaeaData ForceSymbol ;

extern GaeaData UserNeverUseSymbol ;


extern GaeaData RuleOpSymbol ;

extern GaeaData FactOpSymbol ;


extern GaeaData TrueSymbol ;

extern GaeaData FailSymbol ;

extern GaeaData FalseSymbol ;

extern GaeaData AndSymbol ;

extern GaeaData OrSymbol ;

extern GaeaData CutSymbol ;

extern GaeaData GenSymSeedSymbol ;

extern GaeaData DLHandleSymbol ;


extern GaeaData FileReadModeSymbol ;
extern GaeaData FileWriteModeSymbol ;
extern GaeaData FileAppendModeSymbol ;
extern GaeaData FileReadWriteModeSymbol ;
extern ExtObjTypeID EOT_IOStream ;
#define isIOStream(gdt) isGaeaExtObject(EOT_IOStream,gdt)


extern GaeaData SpecialCharSymbol_Newline ;
extern GaeaData SpecialCharSymbol_Tab ;
extern GaeaData SpecialCharSymbol_Space ;


extern GaeaData ConsSymbol ;
extern GaeaData ConsCarVar ;
extern GaeaData ConsCdrVar ;
extern GaeaData ConsTerm ;


extern GaeaCell* BasicCell ;
extern GaeaCell* MainCell ;




extern ExtObjTypeID EOT_Barrier ;
#define isBarrier(gdt) isGaeaExtObject(EOT_Barrier,gdt)

extern GaeaData TimeOutSymbol ;


#define CRCHAR			'\n'
#define COMMENTSTARTCHAR	'%'
#define COMMENTENDCHAR  	'\n'
#define NULLCHAR		'\000'
#define EOSCHAR			NULLCHAR
#define ARGSEP			','
#define ARGBEGIN		'('
#define ARGEND			')'
#define GARGSEP			'|'
#define GARGPAIR		'@'
#define CLAUSEEND		'.'
#define CLAUSECONJ		','
#define QUOTESYMBOLBEGIN	'\''
#define QUOTESYMBOLEND		'\''
#define STRINGBEGIN		'"'
#define STRINGEND		'"'
#define ESCAPECHAR		'\\'
#define PLUSCHAR		'+'
#define MINUSCHAR		'-'
#define ZEROCHAR		'0'
#define DOTCHAR			'.'
#define XTRSYMCHAR		'$'
#define VARPRECHAR		'_'
#define LISTBEGINCHAR		'['
#define LISTENDCHAR		']'
#define LISTARGSEP		','
#define LISTDOTCHAR		'|'
#define ANONYMOUSVARSTR		"_"



extern int Argc ;
extern char** Argv ;


extern GaeaData RoleSymbol ;
extern GaeaData RoleRoleVar ;
extern GaeaData RoleValueVar ;
extern GaeaData RoleTermVar ;
extern GaeaData RoleTerm3 ;


extern ExtObjTypeID EOT_Buffer ;
#define isBuffer(gdt) isGaeaExtObject(EOT_Buffer,gdt)
extern GaeaData ReaderVarPackSymbol ;
extern GaeaData ReaderVarPackArg ;
extern GaeaData ReaderVarPackTerm ;
	       
	       

      









extern void gglobalInit() ;

////////////////////////////////////////////////////////////////////////
#endif
