// -*- Mode: C++ -*-
// 
// This file is generate by tab2h.pl .
// Please edit the original file.
// 
#define SC_HALF_PITCH_L		SC_PITCH_LENGTH/2.0 
#define SC_HALF_PITCH_W		SC_PITCH_WIDTH/2.0 
#define SC_PENALTY_CORNER_X	(SC_HALF_PITCH_L - SC_PENALTY_AREA_LENGTH)
#define SC_PENALTY_CORNER_Y	(SC_PENALTY_AREA_WIDTH/2.0)
#define SC_HALF_PITCH_L_M	(SC_HALF_PITCH_L + 5)
#define SC_HALF_PITCH_W_M	(SC_HALF_PITCH_W + 5)
enum ScLandmarkID {
	SC_LMID_C,
	SC_LMID_GL,
	SC_LMID_GR,
	SC_LMID_LT,
	SC_LMID_LB,
	SC_LMID_RT,
	SC_LMID_RB,
	SC_LMID_CT,
	SC_LMID_CB,
	SC_LMID_PLT,
	SC_LMID_PLC,
	SC_LMID_PLB,
	SC_LMID_PRT,
	SC_LMID_PRC,
	SC_LMID_PRB,
	SC_LMID_GLT,
	SC_LMID_GLB,
	SC_LMID_GRT,
	SC_LMID_GRB,
	SC_LMID_LT30,
	SC_LMID_LT20,
	SC_LMID_LT10,
	SC_LMID_L0,
	SC_LMID_LB10,
	SC_LMID_LB20,
	SC_LMID_LB30,
	SC_LMID_RT30,
	SC_LMID_RT20,
	SC_LMID_RT10,
	SC_LMID_R0,
	SC_LMID_RB10,
	SC_LMID_RB20,
	SC_LMID_RB30,
	SC_LMID_TL50,
	SC_LMID_TL40,
	SC_LMID_TL30,
	SC_LMID_TL20,
	SC_LMID_TL10,
	SC_LMID_T0,
	SC_LMID_TR10,
	SC_LMID_TR20,
	SC_LMID_TR30,
	SC_LMID_TR40,
	SC_LMID_TR50,
	SC_LMID_BL50,
	SC_LMID_BL40,
	SC_LMID_BL30,
	SC_LMID_BL20,
	SC_LMID_BL10,
	SC_LMID_B0,
	SC_LMID_BR10,
	SC_LMID_BR20,
	SC_LMID_BR30,
	SC_LMID_BR40,
	SC_LMID_BR50,
	SC_LMID_LineT,
	SC_LMID_LineB,
	SC_LMID_LineL,
	SC_LMID_LineR,
	SC_LMID_Unknown,
	SC_LMID__MAX
} ;

#define SC_LANDMARK_TABLE	{\
  {SC_LMID_C       , "c"       , ScPos(              0.0,                0.0)},\
  {SC_LMID_GL      , "g l"     , ScPos(    -SC_HALF_PITCH_L,             0.0)},\
  {SC_LMID_GR      , "g r"     , ScPos(     SC_HALF_PITCH_L,             0.0)},\
  {SC_LMID_LT      , "l t"     , ScPos(    -SC_HALF_PITCH_L,      -SC_HALF_PITCH_W) },\
  {SC_LMID_LB      , "l b"     , ScPos(    -SC_HALF_PITCH_L,       SC_HALF_PITCH_W) },\
  {SC_LMID_RT      , "r t"     , ScPos(     SC_HALF_PITCH_L,      -SC_HALF_PITCH_W) },\
  {SC_LMID_RB      , "r b"     , ScPos(     SC_HALF_PITCH_L,       SC_HALF_PITCH_W) },\
  {SC_LMID_CT      , "c t"     , ScPos(              0.0,      -SC_HALF_PITCH_W) },\
  {SC_LMID_CB      , "c b"     , ScPos(              0.0,       SC_HALF_PITCH_W) },\
  {SC_LMID_PLT     , "p l t"   , ScPos(-SC_PENALTY_CORNER_X,  -SC_PENALTY_CORNER_Y) },\
  {SC_LMID_PLC     , "p l c"   , ScPos(-SC_PENALTY_CORNER_X,                0.0) },\
  {SC_LMID_PLB     , "p l b"   , ScPos(-SC_PENALTY_CORNER_X,   SC_PENALTY_CORNER_Y) },\
  {SC_LMID_PRT     , "p r t"   , ScPos( SC_PENALTY_CORNER_X,  -SC_PENALTY_CORNER_Y) },\
  {SC_LMID_PRC     , "p r c"   , ScPos( SC_PENALTY_CORNER_X,                0.0) },\
  {SC_LMID_PRB     , "p r b"   , ScPos( SC_PENALTY_CORNER_X,   SC_PENALTY_CORNER_Y) },\
  {SC_LMID_GLT     , "g l t"   , ScPos(    -SC_HALF_PITCH_L,    -SC_GOAL_WIDTH/2.0)},\
  {SC_LMID_GLB     , "g l b"   , ScPos(    -SC_HALF_PITCH_L,     SC_GOAL_WIDTH/2.0)},\
  {SC_LMID_GRT     , "g r t"   , ScPos(     SC_HALF_PITCH_L,    -SC_GOAL_WIDTH/2.0)},\
  {SC_LMID_GRB     , "g r b"   , ScPos(     SC_HALF_PITCH_L,     SC_GOAL_WIDTH/2.0)},\
  {SC_LMID_LT30    , "l t 30"  , ScPos(  -SC_HALF_PITCH_L_M,                -30)},\
  {SC_LMID_LT20    , "l t 20"  , ScPos(  -SC_HALF_PITCH_L_M,                -20)},\
  {SC_LMID_LT10    , "l t 10"  , ScPos(  -SC_HALF_PITCH_L_M,                -10)},\
  {SC_LMID_L0      , "l 0"     , ScPos(  -SC_HALF_PITCH_L_M,                  0)},\
  {SC_LMID_LB10    , "l b 10"  , ScPos(  -SC_HALF_PITCH_L_M,                 10)},\
  {SC_LMID_LB20    , "l b 20"  , ScPos(  -SC_HALF_PITCH_L_M,                 20)},\
  {SC_LMID_LB30    , "l b 30"  , ScPos(  -SC_HALF_PITCH_L_M,                 30)},\
  {SC_LMID_RT30    , "r t 30"  , ScPos(   SC_HALF_PITCH_L_M,                -30)},\
  {SC_LMID_RT20    , "r t 20"  , ScPos(   SC_HALF_PITCH_L_M,                -20)},\
  {SC_LMID_RT10    , "r t 10"  , ScPos(   SC_HALF_PITCH_L_M,                -10)},\
  {SC_LMID_R0      , "r 0"     , ScPos(   SC_HALF_PITCH_L_M,                  0)},\
  {SC_LMID_RB10    , "r b 10"  , ScPos(   SC_HALF_PITCH_L_M,                 10)},\
  {SC_LMID_RB20    , "r b 20"  , ScPos(   SC_HALF_PITCH_L_M,                 20)},\
  {SC_LMID_RB30    , "r b 30"  , ScPos(   SC_HALF_PITCH_L_M,                 30)},\
  {SC_LMID_TL50    , "t l 50"  , ScPos(              -50,    -SC_HALF_PITCH_W_M)},\
  {SC_LMID_TL40    , "t l 40"  , ScPos(              -40,    -SC_HALF_PITCH_W_M)},\
  {SC_LMID_TL30    , "t l 30"  , ScPos(              -30,    -SC_HALF_PITCH_W_M)},\
  {SC_LMID_TL20    , "t l 20"  , ScPos(              -20,    -SC_HALF_PITCH_W_M)},\
  {SC_LMID_TL10    , "t l 10"  , ScPos(              -10,    -SC_HALF_PITCH_W_M)},\
  {SC_LMID_T0      , "t 0"     , ScPos(                0,    -SC_HALF_PITCH_W_M)},\
  {SC_LMID_TR10    , "t r 10"  , ScPos(               10,    -SC_HALF_PITCH_W_M)},\
  {SC_LMID_TR20    , "t r 20"  , ScPos(               20,    -SC_HALF_PITCH_W_M)},\
  {SC_LMID_TR30    , "t r 30"  , ScPos(               30,    -SC_HALF_PITCH_W_M)},\
  {SC_LMID_TR40    , "t r 40"  , ScPos(               40,    -SC_HALF_PITCH_W_M)},\
  {SC_LMID_TR50    , "t r 50"  , ScPos(               50,    -SC_HALF_PITCH_W_M)},\
  {SC_LMID_BL50    , "b l 50"  , ScPos(              -50,     SC_HALF_PITCH_W_M)},\
  {SC_LMID_BL40    , "b l 40"  , ScPos(              -40,     SC_HALF_PITCH_W_M)},\
  {SC_LMID_BL30    , "b l 30"  , ScPos(              -30,     SC_HALF_PITCH_W_M)},\
  {SC_LMID_BL20    , "b l 20"  , ScPos(              -20,     SC_HALF_PITCH_W_M)},\
  {SC_LMID_BL10    , "b l 10"  , ScPos(              -10,     SC_HALF_PITCH_W_M)},\
  {SC_LMID_B0      , "b 0"     , ScPos(                0,     SC_HALF_PITCH_W_M)},\
  {SC_LMID_BR10    , "b r 10"  , ScPos(               10,     SC_HALF_PITCH_W_M)},\
  {SC_LMID_BR20    , "b r 20"  , ScPos(               20,     SC_HALF_PITCH_W_M)},\
  {SC_LMID_BR30    , "b r 30"  , ScPos(               30,     SC_HALF_PITCH_W_M)},\
  {SC_LMID_BR40    , "b r 40"  , ScPos(               40,     SC_HALF_PITCH_W_M)},\
  {SC_LMID_BR50    , "b r 50"  , ScPos(               50,     SC_HALF_PITCH_W_M)},\
  {SC_LMID_LineT   , "line t"  , ScPos(                0,    -SC_HALF_PITCH_W)},\
  {SC_LMID_LineB   , "line b"  , ScPos(                0,     SC_HALF_PITCH_W)},\
  {SC_LMID_LineL   , "line l"  , ScPos( -SC_HALF_PITCH_L,                0.0)},\
  {SC_LMID_LineR   , "line r"  , ScPos(  SC_HALF_PITCH_L,                0.0)},\
  {SC_LMID_Unknown , "unknown" , ScPos(              0.0,                0.0) },\
  {SC_LMID__MAX, SC_NULLPTR }}


class ScLandmark {
   public:
      ScLandmarkID id ;
      char* namestr ;
      ScPos pos ;
} ;
